diff -u -r icu/source/i18n/regexcmp.cpp icu.new/source/i18n/regexcmp.cpp
--- icu/source/i18n/regexcmp.cpp	2004-12-30 07:25:50.000000000 +0000
+++ icu.new/source/i18n/regexcmp.cpp	2006-08-10 14:51:46.000000000 +0100
@@ -1,4 +1,3 @@
-
 //
 //  file:  regexcmp.cpp
 //
@@ -24,6 +23,7 @@
 #include "util.h"
 #include "cmemory.h"
 #include "cstring.h"
+#include "uvector.h"
 #include "uvectr32.h"
 #include "uassert.h"
 #include "ucln_in.h"
@@ -36,7 +36,6 @@
 #include "regexst.h"
 
 
-
 U_NAMESPACE_BEGIN
 
 
@@ -60,7 +59,7 @@
     fCharNum          = 0;
     fQuoteMode        = FALSE;
     fInBackslashQuote = FALSE;
-    fModeFlags        = fRXPat->fFlags;
+    fModeFlags        = fRXPat->fFlags & URX_USER_MODE_FLAGS;
     fEOLComments      = TRUE;
 
     fMatchOpenParen   = -1;
@@ -239,15 +238,41 @@
     // The pattern has now been read and processed, and the compiled code generated.
     //
 
-    // Back-reference fixup
+    // Back-reference and condition fixup
     //
     int32_t loc;
     for (loc=0; loc<fRXPat->fCompiledPat->size(); loc++) {
         int32_t op = fRXPat->fCompiledPat->elementAti(loc);
         int32_t opType = URX_TYPE(op);
-        if (opType == URX_BACKREF || opType == URX_BACKREF_I) {
+
+        // Mutate named backrefs into numbered ones
+        if (opType == URX_NAMED_BACKREF || opType == URX_NMD_BACKREF_I || opType == URX_NAMED_CONDTN) {
+            int32_t nameIndex = URX_VAL(op);
+            int32_t where = fRXPat->fNamedGroupMap->elementAti(nameIndex);
+
+            if (where < 0) {
+                error (U_REGEX_UNKNOWN_GROUP_NAME);
+                break;
+            }
+
+            if (opType == URX_NAMED_BACKREF) {
+                opType = URX_BACKREF;
+            } else if (opType == URX_NMD_BACKREF_I) {
+                opType = URX_BACKREF_I;
+            } else if (opType == URX_NAMED_CONDTN) {
+                opType = URX_CONDITION;
+            }
+            op = URX_BUILD(opType, where + 1);
+        }
+
+        if (opType == URX_BACKREF || opType == URX_BACKREF_I || opType == URX_CONDITION) {
             int32_t where = URX_VAL(op);
             if (where > fRXPat->fGroupMap->size()) {
+                // Perl allows conditional expressions with nonexistent numeric conditions :-(
+                if (opType == URX_CONDITION) {
+                    fRXPat->fCompiledPat->setElementAt(URX_BUILD(URX_NOP, 0), loc);
+                    break;
+                }
                 error(U_REGEX_INVALID_BACK_REF);
                 break;
             }
@@ -380,8 +405,27 @@
             //   save from the location on the top of the parentheses stack.
             int32_t savePosition = fParenStack.popi();
             int32_t op = fRXPat->fCompiledPat->elementAti(savePosition);
-            U_ASSERT(URX_TYPE(op) == URX_NOP);  // original contents of reserved location
-            op = URX_BUILD(URX_STATE_SAVE, fRXPat->fCompiledPat->size()+1);
+            UBool   isConditional = FALSE;
+
+            // Check for condition expressions; '|' needs slightly different handling
+            // inside these.
+            if (fModeFlags & URX_INSIDE_CONDITIONAL) {
+                int32_t opType = URX_TYPE(op);
+
+                if (fModeFlags & URX_GOT_COND_ELSE) {
+                    error (U_REGEX_TOO_MANY_BRANCHES);
+                }
+
+                fModeFlags |= URX_GOT_COND_ELSE;
+
+                U_ASSERT(opType == URX_JMP || opType == URX_STATE_SAVE);
+
+                op = URX_BUILD(opType, fRXPat->fCompiledPat->size() + 1);
+            } else {         
+                U_ASSERT(URX_TYPE(op) == URX_NOP);  // original contents of reserved location
+                op = URX_BUILD(URX_STATE_SAVE, fRXPat->fCompiledPat->size() + 1);
+            }
+
             fRXPat->fCompiledPat->setElementAt(op, savePosition);
 
             // Append an JMP operation into the compiled pattern.  The operand for
@@ -394,15 +438,60 @@
             // This registers if for fixup when this block's close paren is encountered.
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);
 
-            // Append a NOP to the compiled pattern.  This is the slot reserved
-            //   for a SAVE in the event that there is yet another '|' following
-            //   this one.
-            fRXPat->fCompiledPat->addElement(URX_BUILD(URX_NOP, 0), *fStatus);
-            fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);
+            if (!(fModeFlags & URX_INSIDE_CONDITIONAL)) {
+                // Append a NOP to the compiled pattern.  This is the slot reserved
+                //   for a SAVE in the event that there is yet another '|' following
+                //   this one.
+                fRXPat->fCompiledPat->addElement(URX_BUILD(URX_NOP, 0), *fStatus);
+                fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);
+            }
         }
         break;
 
 
+    case doOpenPyNamedParen:
+        // Python-style named paren.
+        //   Scan the name and add it to the named groups list, then proceed
+        //   as normal
+        {
+            UnicodeString *name = scanName();
+
+            if (!name) {
+                break;
+            }
+
+            if (name->length() == 0) {
+                error(U_REGEX_BAD_GROUP_NAME);
+            }
+            
+            int32_t nameCount = fRXPat->fNamedGroups->size();
+            int32_t nameIndex;
+            for (nameIndex = 0; nameIndex < nameCount; ++nameIndex) {
+                UnicodeString *other = (UnicodeString *)fRXPat->fNamedGroups->elementAt(nameIndex);
+                
+                if (*other == *name) {
+                    int32_t curGroup = fRXPat->fNamedGroupMap->elementAti(nameIndex);
+                    if (curGroup < 0) {
+                        fRXPat->fNamedGroupMap->setElementAt(fRXPat->fGroupMap->size(),
+                                                             *fStatus);
+                        break;
+                    } else {
+                        error(U_REGEX_DUPLICATE_GROUP_NAME);
+                        break;
+                    }
+                }
+            }
+
+            if (nameIndex >= nameCount) {
+                fRXPat->fNamedGroups->addElement(name, *fStatus);
+                fRXPat->fNamedGroupMap->addElement(fRXPat->fGroupMap->size(), *fStatus);
+            } else {
+                delete name;
+            }
+        }
+
+        // No break; fall through here
+            
     case doOpenCaptureParen:
         // Open Paren.
         //   Compile to a
@@ -438,6 +527,9 @@
             fParenStack.push(fRXPat->fCompiledPat->size()-3, *fStatus);   // The first  NOP location
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);   // The second NOP loc
 
+            // No longer inside a conditional (if we were)
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
+
             // Save the mapping from group number to stack frame variable position.
             fRXPat->fGroupMap->addElement(varsLoc, *fStatus);
         }
@@ -460,8 +552,11 @@
             fParenStack.push(plain,      *fStatus);                       // Begin a new frame.
             fParenStack.push(fRXPat->fCompiledPat->size()-2, *fStatus);   // The first  NOP location
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);   // The second NOP loc
+
+            // No longer inside a conditional (if we were)
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
         }
-         break;
+        break;
 
 
     case doOpenAtomicParen:
@@ -488,9 +583,61 @@
             fParenStack.push(atomic, *fStatus);                           // Frame type.
             fParenStack.push(fRXPat->fCompiledPat->size()-3, *fStatus);   // The first NOP
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);   // The second NOP
+
+            // No longer inside a conditional (if we were)
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
         }
         break;
 
+    case doCondOpenLookAhead:
+        // Conditional expression using lookahead.
+        //
+        // Compiles to
+        //
+        //    NOP                 reserved for quantifiers
+        //    START_LA            start lookahead
+        //    SAVE_STATE          points to the false-part
+        //    NOP                 reserved for quantifiers on internal block (unused)
+        //    NOP                 reserved for STATE_SAVE if we see an '|' in the condition
+        //    pattern code        the code implementing the pattern
+        //    END_LA              finish lookahead
+        //    true-part           the bit that gets run if the lookahead succeeds
+        //    JMP                 to the very end
+        //    false-part          the bit that gets run if the lookahead fails
+        //
+        // This results in *two* entries on the paren stack.
+        {
+            int32_t nop = URX_BUILD(URX_NOP, 0);
+
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+
+            int32_t dataLoc = fRXPat->fDataSize;
+            fRXPat->fDataSize += 2;
+            int32_t op = URX_BUILD(URX_LA_START, dataLoc);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+
+            fRXPat->fCompiledPat->addElement(URX_BUILD(URX_STATE_SAVE, 0), *fStatus);
+            
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+            
+            // On the paren stack, start a frame for the conditional expression
+            fParenStack.push(fModeFlags, *fStatus);
+            fParenStack.push(condWithMatch, *fStatus);
+            fParenStack.push(fRXPat->fCompiledPat->size() - 5, *fStatus);  // The NOP location
+            fParenStack.push(fRXPat->fCompiledPat->size() - 3, *fStatus);  // The SAVE_STATE location
+            
+            // Now push a frame for the lookahead expression itself
+            fParenStack.push((fModeFlags & ~URX_GOT_COND_ELSE)
+                             | URX_INSIDE_CONDITIONAL, *fStatus);
+            fParenStack.push(lookAheadCE, *fStatus);                       // This is a lookahead test
+            fParenStack.push(fRXPat->fCompiledPat->size() - 2, *fStatus);  // The first NOP
+            fParenStack.push(fRXPat->fCompiledPat->size() - 1, *fStatus);  // The second NOP
+
+            // The lookahead part isn't in the then-else part of the expression
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
+        }
+        break;
 
     case doOpenLookAhead:
         // Positive Look-ahead   (?=  stuff  )
@@ -520,6 +667,58 @@
             fParenStack.push(lookAhead, *fStatus);                        // Frame type.
             fParenStack.push(fRXPat->fCompiledPat->size()-2, *fStatus);   // The first  NOP location
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);   // The second NOP location
+
+            // No longer inside a conditional (if we were)
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
+        }
+        break;
+
+    case doCondOpenLookAheadNeg:
+        // Conditional expression using negated lookahead.
+        //
+        // Compiles to
+        //
+        //    NOP                       reserved for quantifiers
+        //    START_LA                  start lookahead
+        //    SAVE_STATE                points to the true-part
+        //    NOP                       reserved for STATE_SAVE if we see an '|' in the cond.
+        //    pattern code              the code implementing the pattern
+        //    END_LA                    finish lookahead
+        //    JMP                       to false-part
+        //    true-part                 the bit that gets run if the lookahead succeeds
+        //    JMP                       to the very end
+        //    false-part                the bit that gets run if the lookahead fails
+        //
+        // This results in *two* entries on the paren stack.
+        {
+            int32_t nop = URX_BUILD(URX_NOP, 0);
+
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+
+            int32_t dataLoc = fRXPat->fDataSize;
+            fRXPat->fDataSize += 2;
+            int32_t op = URX_BUILD(URX_LA_START, dataLoc);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+
+            fRXPat->fCompiledPat->addElement(URX_BUILD(URX_STATE_SAVE, 0), *fStatus);
+            
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+            
+            // On the paren stack, start a frame for the conditional expression
+            fParenStack.push(fModeFlags, *fStatus);
+            fParenStack.push(condWithMatch, *fStatus);
+            fParenStack.push(fRXPat->fCompiledPat->size() - 4, *fStatus);  // The NOP location
+            fParenStack.push(0, *fStatus);  // Dummy, will point to JMP to false-part later
+            
+            // Now push a frame for the lookahead expression itself
+            fParenStack.push((fModeFlags & ~URX_GOT_COND_ELSE)
+                             | URX_INSIDE_CONDITIONAL, *fStatus);
+            fParenStack.push(negLookAheadCE, *fStatus);                    // This is a !lookahead test
+            fParenStack.push(fRXPat->fCompiledPat->size() - 2, *fStatus);  // The SAVE_STATE location
+            fParenStack.push(fRXPat->fCompiledPat->size() - 1, *fStatus);  // The second NOP
+
+            // The lookahead part isn't in the then-else part of the expression
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
         }
         break;
 
@@ -557,6 +756,69 @@
         }
         break;
 
+    case doCondOpenLookBehind:
+        // Conditional expression using lookbehind.
+        //
+        // Compiles to
+        //
+        //    NOP                reserved for quantifiers
+        //    LB_START           start lookbehind
+        //    STATE_SAVE         points to the false-part
+        //    LB_CONT            continue from here
+        //    -                  holds min match length
+        //    -                  holds max match length
+        //    NOP                reserved for quantifiers on the internal block
+        //    NOP                reserved for STATE_SAVE if we see an '|' in the condition
+        //    pattern code       code for the lookbehind expression
+        //    LB_END             check match length, restore input len
+        //    LA_END             restore stack and input pos (also cancels STATE_SAVE)
+        //    true-part          the bit that gets run if the lookbehind succeeds
+        //    JMP                to the very end
+        //    false-part         the bit that gets run if the lookbehind fails
+        //
+        // This results in *two* entries on the paren stack.
+        {
+            int32_t nop = URX_BUILD(URX_NOP, 0);
+
+            // Emit the instructions
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+
+            int32_t dataLoc = fRXPat->fDataSize;
+            fRXPat->fDataSize += 4;
+
+            int32_t op = URX_BUILD(URX_LB_START, dataLoc);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+
+            op = URX_BUILD(URX_STATE_SAVE, 0);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+
+            op = URX_BUILD(URX_LB_CONT, dataLoc);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+            fRXPat->fCompiledPat->addElement(0, *fStatus); // min match len; filled in later
+            fRXPat->fCompiledPat->addElement(0, *fStatus); // max match len; filled in later
+
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+
+            // Now build a frame for the conditional expression
+            fParenStack.push(fModeFlags, *fStatus);
+            fParenStack.push(condWithMatch, *fStatus);
+            fParenStack.push(fRXPat->fCompiledPat->size() - 8, *fStatus); // The NOP
+            fParenStack.push(fRXPat->fCompiledPat->size() - 6, *fStatus); // The SAVE_STATE
+
+            // Now push a frame for the lookbehind itself
+            fParenStack.push((fModeFlags & ~URX_GOT_COND_ELSE)
+                             | URX_INSIDE_CONDITIONAL, *fStatus);
+            fParenStack.push(lookBehindCE, *fStatus);
+            fParenStack.push(fRXPat->fCompiledPat->size() - 2, *fStatus); // The first NOP
+            fParenStack.push(fRXPat->fCompiledPat->size() - 1, *fStatus); // The second NOP
+
+            // The lookbehind part isn't in the then-else part of the expression
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
+        }
+        break;
+
+
     case doOpenLookBehind:
         {
             //   Compile a (?<= look-behind open paren.
@@ -605,10 +867,75 @@
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);   // The 2nd   NOP location
             
             // The final two instructions will be added when the ')' is encountered.
+
+            // No longer inside a conditional (if we were)
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
         }
 
         break;
 
+    case doCondOpenLookBehindNeg:
+        // Conditional expression using negated lookbehind.
+        //
+        // Compiles to
+        //
+        //    NOP               reserved for quantifiers
+        //    STATE_SAVE        points to the false-part
+        //    LB_START          start lookbehind
+        //    LBN_CONT          continue from here
+        //    -                 holds min match length
+        //    -                 holds max match length
+        //    -                 location to jump to on FAIL (points at STATE_POP)
+        //    NOP               reserved for quantifiers on the internal block
+        //    NOP               reserved for STATE_SAVE if we see a '|' in the condition
+        //    pattern code      code for the lookbehind expression
+        //    LBN_END           check match length, then FAIL
+        //    STATE_POP         pop the state we saved above
+        //    true-part         the bit that gets run if the neg. lookbehind succeeds
+        //    JMP               to the very end
+        //    false-part        the bit that gets run if the lookbehind fails
+        {
+            int32_t nop = URX_BUILD(URX_NOP, 0);
+
+            // Emit the instructions
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+            
+            int32_t dataLoc = fRXPat->fDataSize;
+            fRXPat->fDataSize += 4;
+
+            int32_t op = URX_BUILD(URX_STATE_SAVE, 0);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+
+            op = URX_BUILD(URX_LB_START, dataLoc);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+            
+            op = URX_BUILD(URX_LBN_CONT, dataLoc);
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+            fRXPat->fCompiledPat->addElement(0, *fStatus); // min length, filled in later
+            fRXPat->fCompiledPat->addElement(0, *fStatus); // max length, filled in later
+            fRXPat->fCompiledPat->addElement(0, *fStatus); // continue loc., filled in later
+            
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+            fRXPat->fCompiledPat->addElement(nop, *fStatus);
+
+            // On the paren stack, start a frame for the conditional expression
+            fParenStack.push(fModeFlags, *fStatus);
+            fParenStack.push(condWithMatch, *fStatus);
+            fParenStack.push(fRXPat->fCompiledPat->size() - 9, *fStatus); // The NOP location
+            fParenStack.push(fRXPat->fCompiledPat->size() - 8, *fStatus); // The STATE_SAVE location
+            
+            // Now push a frame for the lookbehind expressioqn itself
+            fParenStack.push((fModeFlags & ~URX_GOT_COND_ELSE)
+                             | URX_INSIDE_CONDITIONAL, *fStatus);
+            fParenStack.push(lookBehindNCE, *fStatus);
+            fParenStack.push(fRXPat->fCompiledPat->size() - 2, *fStatus); // The first NOP location
+            fParenStack.push(fRXPat->fCompiledPat->size() - 1, *fStatus); // The second NOP location
+
+            // The lookbehind part isn't in the then-else part of the expression
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
+        }
+        break;
+
     case doOpenLookBehindNeg:
         {
             //   Compile a (?<! negated look-behind open paren.
@@ -659,11 +986,109 @@
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);   // The 2nd   NOP location
             
             // The final two instructions will be added when the ')' is encountered.
+
+            // No longer inside a conditional (if we were)
+            fModeFlags &= ~URX_INSIDE_CONDITIONAL;
         }
         break;
 
     case doConditionalExpr:
-        // Conditionals such as (?(1)a:b)
+        // Conditionals such as (?(1)a|b).  This handles the simple cases where we just want to test
+        // for a match with a capture group.
+        //
+        // Compiles to
+        //
+        //     NOP          reserved for quantifiers
+        //     CONDITION    skip the next instruction if the condition is true
+        //     JMP          goes to the false-branch part or the end if there is no false-branch
+        //     true-branch
+        //     JMP          gote to the end part
+        //     false-branch
+        //
+        {
+            UnicodeString *name = scanName(TRUE);
+
+            if (!name) {
+                break;
+            }
+
+            int32_t groupNum = 0;
+            int32_t nameLen = name->length();
+            int32_t numCaptureGroups = fRXPat->fGroupMap->size();
+            int32_t idx;
+            // Scan things that look like group numbers as a group number
+            for (idx = 0; idx < nameLen;) {
+                UChar32 c = name->char32At(idx);
+                int32_t digit = u_charDigitValue(c);
+                
+                if (digit < 0) {
+                    groupNum = -1;
+                    break;
+                }
+
+                groupNum = groupNum * 10 + digit;
+
+                if (RegexStaticSets::gStaticSets->fRuleDigits->contains(c) == FALSE) {
+                    groupNum = -1;
+                    break;
+                }
+
+                // Move to the next code point
+                idx = name->moveIndex32(idx, 1);
+            }
+
+            // Add a NOP so that the '*' operator can replace it later if necessary
+            fRXPat->fCompiledPat->addElement(URX_BUILD(URX_NOP, 0), *fStatus);
+
+            // If we get here with groupNum set to -1, we assume that we have a name
+            if (groupNum < 0) {
+                int32_t nameIndex;
+                int32_t nameCount = fRXPat->fNamedGroups->size ();
+                for (nameIndex = 0; nameIndex < nameCount; ++nameIndex) {
+                    UnicodeString *otherName = (UnicodeString *)fRXPat->fNamedGroups->elementAt(nameIndex);
+                    
+                    if (*otherName == *name)
+                        break;
+                }
+
+                if (nameIndex == nameCount) {
+                    fRXPat->fNamedGroups->addElement(name, *fStatus);
+                    fRXPat->fNamedGroupMap->addElement(-1, *fStatus);
+                } else {
+                    delete name;
+                }
+
+                // Add a URX_NAMED_CONDTN instruction; this will be replaced later
+                int32_t op = URX_BUILD(URX_NAMED_CONDTN, nameIndex);
+                fRXPat->fCompiledPat->addElement(op, *fStatus);
+            } else {
+                if (groupNum == 0) {
+                    error(U_REGEX_INVALID_BACK_REF);
+                }
+                
+                int32_t op = URX_BUILD(URX_CONDITION, groupNum);
+                fRXPat->fCompiledPat->addElement(op, *fStatus);
+            }
+
+            // If URX_CONDITION succeeds, it skips the next instruction; this jump either
+            // points to the thing after the '|', or to the very end of the conditional expr
+            fRXPat->fCompiledPat->addElement(URX_BUILD(URX_JMP, 0), *fStatus);
+
+            // Push a frame onto the paren stack
+            fParenStack.push(fModeFlags, *fStatus);                             // Match mode state
+            fParenStack.push(conditional, *fStatus);                            // Begin a new frame
+            fParenStack.push(fRXPat->fCompiledPat->size() - 3, *fStatus);       // The first NOP location
+            fParenStack.push(fRXPat->fCompiledPat->size() - 1, *fStatus);       // The JMP location
+
+            // We're now inside a conditional expression
+            fModeFlags = (fModeFlags & ~URX_GOT_COND_ELSE) | URX_INSIDE_CONDITIONAL;
+        }
+        break;
+
+
+    case doUnimplCondition:
+        // Unimplemented conditional match types
+
     case doPerlInline:
         // Perl inline-condtionals.  (?{perl code}a|b) We're not perl, no way to do them.
         error(U_REGEX_UNIMPLEMENTED);
@@ -1183,12 +1608,18 @@
                 nextCharLL();
             }
 
+            // If the user specifies \0, it's an invalid back-reference
+            if (groupNum == 0) {
+                error(U_REGEX_INVALID_BACK_REF);
+            } else {
+                U_ASSERT(groupNum > 0);
+            }
+
             // Scan of the back reference in the source regexp is complete.  Now generate
             //  the compiled code for it. 
             // Because capture groups can be forward-referenced by back-references,
             //  we fill the operand with the capture group number.  At the end
             //  of compilation, it will be changed to the variable's location.
-            U_ASSERT(groupNum > 0);
             int32_t  op;
             if (fModeFlags & UREGEX_CASE_INSENSITIVE) {
                 op = URX_BUILD(URX_BACKREF_I, groupNum);
@@ -1199,6 +1630,47 @@
         }
         break;
 
+    case doPyNamedBackRef:
+        // Named backreference.
+        {
+            // Find the name in the name table.  We must have seen the name
+            // already at this point, otherwise using it is invalid.
+            UnicodeString *name = scanName();
+
+            if (!name) {
+                break;
+            }
+
+            if (name->length() == 0) {
+                error(U_REGEX_BAD_GROUP_NAME);
+                break;
+            }
+
+            int32_t nameIndex;
+            int32_t nameCount = fRXPat->fNamedGroups->size ();
+            for (nameIndex = 0; nameIndex < nameCount; ++nameIndex) {
+                UnicodeString *otherName = (UnicodeString *)fRXPat->fNamedGroups->elementAt(nameIndex);
+
+                if (*otherName == *name)
+                    break;
+            }
+
+            if (nameIndex == nameCount) {
+                fRXPat->fNamedGroups->addElement(name, *fStatus);
+                fRXPat->fNamedGroupMap->addElement(-1, *fStatus);
+            } else {
+                delete name;
+            }
+
+            int32_t op;
+            if (fModeFlags & UREGEX_CASE_INSENSITIVE) {
+                op = URX_BUILD(URX_NMD_BACKREF_I, nameIndex);
+            } else {
+                op = URX_BUILD(URX_NAMED_BACKREF, nameIndex);
+            }
+            fRXPat->fCompiledPat->addElement(op, *fStatus);
+        }
+        break;
 
     case doPossessivePlus:
         // Possessive ++ quantifier.
@@ -1332,8 +1804,10 @@
 
     case doSetMatchMode:
         // We've got a (?i) or similar.  The match mode is being changed, but
-        //   the change is not scoped to a parenthesized block.
-        fModeFlags = fNewModeFlags;
+        //   the change is not scoped to a parenthesized block.  Make sure we keep our
+        //   special state flags.
+        fModeFlags = ((fNewModeFlags & URX_USER_MODE_FLAGS) 
+                      | (fModeFlags & URX_RESERVED_MODE_FLAGS));
 
         // Prevent any string from spanning across the change of match mode.
         //   Otherwise the pattern "abc(?i)def" would make a single string of "abcdef" 
@@ -1363,7 +1837,7 @@
             fParenStack.push(fRXPat->fCompiledPat->size()-1, *fStatus);   // The second NOP
 
             // Set the current mode flags to the new values.
-            fModeFlags = fNewModeFlags;
+            fModeFlags = fNewModeFlags & ~URX_INSIDE_CONDITIONAL;
         }
         break;
 
@@ -1733,11 +2207,12 @@
     switch (patIdx) {
     case plain:
     case flags:
+    case conditional:
         // No additional fixups required.
         //   (Grouping-only parentheses)
         break;
     case capturing:
-        // Capturing Parentheses.
+        // Capturing Parentheses (possibly named).
         //   Insert a End Capture op into the pattern.
         //   The frame offset of the variables for this cg is obtained from the
         //       start capture op and put it into the end-capture op.
@@ -1763,9 +2238,11 @@
         }
         break;
 
+    case lookAheadCE:
     case lookAhead:
         {
-            int32_t  startOp = fRXPat->fCompiledPat->elementAti(fMatchOpenParen-1);
+            int32_t startOfs = patIdx == lookAhead ? 1 : 2;
+            int32_t  startOp = fRXPat->fCompiledPat->elementAti(fMatchOpenParen - startOfs);
             U_ASSERT(URX_TYPE(startOp) == URX_LA_START);
             int32_t dataLoc  = URX_VAL(startOp);
             int32_t op       = URX_BUILD(URX_LA_END, dataLoc);
@@ -1773,6 +2250,7 @@
         }
         break;
 
+    case negLookAheadCE:
     case negLookAhead:
         {
             // See comment at doOpenLookAheadNeg
@@ -1781,8 +2259,18 @@
             int32_t dataLoc  = URX_VAL(startOp);
             int32_t op       = URX_BUILD(URX_LA_END, dataLoc);
             fRXPat->fCompiledPat->addElement(op, *fStatus);
-             op              = URX_BUILD(URX_FAIL, 0);
-            fRXPat->fCompiledPat->addElement(op, *fStatus);
+
+            if (patIdx == negLookAhead) {
+                op = URX_BUILD(URX_FAIL, 0);
+                fRXPat->fCompiledPat->addElement(op, *fStatus);
+            } else {
+                // Build a jump to the false-part and set the field of the conditional's
+                // stack frame to point at it so it'll get fixed up.
+                op = URX_BUILD(URX_JMP, 0);
+                fRXPat->fCompiledPat->addElement(op, *fStatus);
+                fParenStack.setElementAt(fRXPat->fCompiledPat->size() - 1,
+                                         fParenStack.size() - 1);
+            }
 
             // Patch the URX_SAVE near the top of the block.
             int32_t saveOp   = fRXPat->fCompiledPat->elementAti(fMatchOpenParen);
@@ -1793,12 +2281,14 @@
         }
         break;
 
+    case lookBehindCE:
     case lookBehind:
         {
             // See comment at doOpenLookBehind.
             
             // Append the URX_LB_END and URX_LA_END to the compiled pattern.
-            int32_t  startOp = fRXPat->fCompiledPat->elementAti(fMatchOpenParen-4);
+            int32_t startOfs = patIdx == lookBehind ? 4 : 5;
+            int32_t  startOp = fRXPat->fCompiledPat->elementAti(fMatchOpenParen - startOfs);
             U_ASSERT(URX_TYPE(startOp) == URX_LB_START);
             int32_t dataLoc  = URX_VAL(startOp);
             int32_t op       = URX_BUILD(URX_LB_END, dataLoc);
@@ -1826,14 +2316,13 @@
         }
         break;
 
-
-
+    case lookBehindNCE:
     case lookBehindN:
         {
             // See comment at doOpenLookBehindNeg.
             
             // Append the URX_LBN_END to the compiled pattern.
-            int32_t  startOp = fRXPat->fCompiledPat->elementAti(fMatchOpenParen-5);
+            int32_t  startOp = fRXPat->fCompiledPat->elementAti(fMatchOpenParen - 5);
             U_ASSERT(URX_TYPE(startOp) == URX_LB_START);
             int32_t dataLoc  = URX_VAL(startOp);
             int32_t op       = URX_BUILD(URX_LBN_END, dataLoc);
